VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Copyright (C) 2006 Kristian. S.Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' NOTE: This class does most likely belong more to the other project, but due to the use
' of type libraries to retrieve the saveable properties, the class cannot be compiled there
' as in that case, that library would be lost. Using ActiveX-EXE is not an option.

' Savable properties
Public AutoStart As Boolean
Public MaxConnections As Long
Public MaxLogonAttempts As Long
Public MaxIdle As Long
Public BytesRecieved As Long
Public BytesSent As Long
Public TotalConnections As Long
Public TotalTime As Date
Public WelcomeString As String
Public GoodbyeString As String
Public ServerPort As Long
Public UseLogging As Boolean

Public Property Get XML(Name As String) As SaveTypes

    ' Return how the different properties should be saved
    Select Case LCase(Name)
        Case "maxconnections", "bytesrecieved", "bytessent", "totalconnections", "welcomestring", "goodbyestring", _
              "serverport", "uselogging", "maxidle", "maxlogonattempts", "totaltime"
            XML = Save_Element
        Case Else
            XML = Save_Disallow
    End Select

End Property

Public Function Clone() As clsSettings

    ' Firstly, create a new instance
    Set Clone = New clsSettings

    ' Then, set its content
    With Clone
        .MaxConnections = MaxConnections
        .MaxLogonAttempts = MaxLogonAttempts
        .MaxIdle = MaxIdle
        .BytesRecieved = BytesRecieved
        .BytesSent = BytesSent
        .TotalConnections = TotalConnections
        .TotalTime = TotalTime
        .WelcomeString = WelcomeString
        .GoodbyeString = GoodbyeString
        .ServerPort = ServerPort
        .UseLogging = UseLogging
    End With

End Function

Private Sub Class_Initialize()

    ' Set default values
    WelcomeString = "200 TelnetServer " & App.Major & "." & App.Minor & "." & App.Revision & " ready."
    GoodbyeString = "201 Goodbye."
    ServerPort = 23
    UseLogging = True
    MaxConnections = 10
    MaxLogonAttempts = 3

End Sub
