VERSION 5.00
Begin VB.Form frmSettings 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Settings"
   ClientHeight    =   7470
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   6270
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   ScaleHeight     =   498
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   418
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Height          =   375
      Left            =   2760
      TabIndex        =   16
      Top             =   6960
      Width           =   1575
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   4440
      TabIndex        =   15
      Top             =   6960
      Width           =   1575
   End
   Begin VB.Frame frameMessages 
      Caption         =   "Messages:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2775
      Left            =   240
      TabIndex        =   9
      Top             =   3720
      Width           =   5775
      Begin VB.PictureBox picMessages 
         BorderStyle     =   0  'None
         Height          =   2295
         Left            =   120
         ScaleHeight     =   153
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   361
         TabIndex        =   10
         Top             =   240
         Width           =   5415
         Begin VB.TextBox txtLogonMessage 
            Height          =   885
            Left            =   1800
            MultiLine       =   -1  'True
            ScrollBars      =   2  'Vertical
            TabIndex        =   12
            Top             =   240
            Width           =   3375
         End
         Begin VB.TextBox txtLogoffMessage 
            Height          =   915
            Left            =   1800
            MultiLine       =   -1  'True
            ScrollBars      =   2  'Vertical
            TabIndex        =   11
            Top             =   1200
            Width           =   3375
         End
         Begin VB.Label lblLogonMessage 
            Caption         =   "&Logon message:"
            Height          =   255
            Left            =   360
            TabIndex        =   14
            Top             =   600
            Width           =   1335
         End
         Begin VB.Label lblLogoffMessage 
            Caption         =   "&Logoff message:"
            Height          =   255
            Left            =   360
            TabIndex        =   13
            Top             =   1560
            Width           =   1335
         End
      End
   End
   Begin VB.Frame frameServer 
      Caption         =   "Server:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3135
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   5775
      Begin VB.CheckBox chkAutoStart 
         Caption         =   "&Start server automatically"
         Height          =   255
         Left            =   480
         TabIndex        =   17
         Top             =   2400
         Width           =   2295
      End
      Begin VB.PictureBox picServer 
         BorderStyle     =   0  'None
         Height          =   2055
         Left            =   120
         ScaleHeight     =   137
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   369
         TabIndex        =   1
         Top             =   240
         Width           =   5535
         Begin VB.CheckBox chkUseLogging 
            Caption         =   "&Use logging"
            Height          =   255
            Left            =   360
            TabIndex        =   8
            Top             =   1800
            Width           =   1695
         End
         Begin VB.TextBox txtMaxIdle 
            Height          =   285
            Left            =   2880
            TabIndex        =   7
            Top             =   1200
            Width           =   2295
         End
         Begin VB.TextBox txtMaxConnections 
            Height          =   285
            Left            =   2880
            TabIndex        =   5
            Top             =   840
            Width           =   2295
         End
         Begin VB.TextBox txtServerPort 
            Height          =   285
            Left            =   2880
            TabIndex        =   3
            Top             =   480
            Width           =   2295
         End
         Begin VB.Label lblMaxIdle 
            Caption         =   "M&ax idle (seconds):"
            Height          =   255
            Left            =   360
            TabIndex        =   6
            Top             =   1215
            Width           =   1455
         End
         Begin VB.Label lblMaxConnections 
            Caption         =   "&Max connections:"
            Height          =   255
            Left            =   360
            TabIndex        =   4
            Top             =   855
            Width           =   1335
         End
         Begin VB.Label lblServerPort 
            Caption         =   "&Server port:"
            Height          =   255
            Left            =   360
            TabIndex        =   2
            Top             =   495
            Width           =   1335
         End
      End
   End
End
Attribute VB_Name = "frmSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


' Copyright (C) 2006 Kristian. S.Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Public Sub LoadSettings()

    ' Retrieve settings
    With Application.Settings
        txtLogoffMessage = .GoodbyeString
        txtLogonMessage = .WelcomeString
        txtMaxConnections = .MaxConnections
        txtMaxIdle = .MaxIdle
        txtServerPort = .ServerPort
        chkUseLogging.Value = IIf(.UseLogging, 1, 0)
        chkAutoStart.Value = IIf(.AutoStart, 1, 0)
    End With

End Sub

Public Sub SaveSettings()

    ' Save settings
    With Application.Settings
        .GoodbyeString = txtLogoffMessage
        .WelcomeString = txtLogonMessage
        .MaxConnections = txtMaxConnections
        .MaxIdle = txtMaxIdle
        .ServerPort = txtServerPort
        .UseLogging = (chkUseLogging.Value = 1)
        .AutoStart = (chkAutoStart.Value = 1)
    End With

End Sub

Private Sub cmdOk_Click()

    ' Save settings
    SaveSettings

    ' Close the form
    Unload Me

End Sub

Private Sub cmdCancel_Click()

    ' Here too
    Unload Me

End Sub

Private Sub Form_Load()

    ' Make some text boxes numberic
    SetNumber txtMaxConnections, True
    SetNumber txtMaxIdle, True
    SetNumber txtServerPort, True

End Sub
